routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', ['uses' => 'VendingController@showCoin', 'as' => 'home']);
Route::get('/refund', ['uses' => 'VendingController@refund', 'as' => 'refund']);
Route::get('/select', ['uses' => 'VendingController@selectProduct', 'as' => 'select']);

Route::group(['prefix' => '/coin', 'as' => 'coin.'], function (){
    Route::get('/insert', ['uses' => 'CoinController@insertCoin', 'as' => 'insert']);
});

Route::group(['prefix' => '/product', 'as' => 'product.'], function (){
    Route::get('/', ['uses' => 'ProductController@show', 'as' => 'show']);
});

app/Coin.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Coin extends Model
{
    public $timestamps = false;

    public static function getTotal()
    {
        return Coin::where('amount', '>', 0)->sum(DB::raw('value * amount'));
    }
}

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    public $timestamps = false;
}

app/Http/Controllers/CoinController.php
<?php

namespace App\Http\Controllers;

use App\Coin;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class CoinController extends Controller
{
    public function insertCoin(Request $request)
    {
        $validator = $this->validatorCoin($request->all());

        if ($validator->fails()){
            return redirect()->back()->withInput($request->all())->withErrors($validator->errors());
        }

        $coin = Coin::where('value', $request->input('coin_value'))->increment('amount');

        return redirect()->route('home');
    }

    private function validatorCoin($data = [])
    {
        return Validator::make($data, [
            'coin_value' => 'required|numeric|min:1'
        ]);
    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Coin;
use App\Product;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    public function list(Request $request)
    {
        $keyword = $request->input('keyword');
        $products = Product::where('name', 'LIKE', "%$keyword%")->paginate(6);

        return response()->json($products, 200);
    }

    public function show()
    {
        $data['products'] = Product::all();
        $data['fund'] = Coin::getTotal();

        return view('product', $data);
    }
}

app/Http/Controllers/VendingController.php
<?php

namespace App\Http\Controllers;

use App\Coin;
use App\Product;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class VendingController extends Controller
{
    public function showCoin()
    {
        $data['coins'] = Coin::all();
        $data['total'] = Coin::getTotal();

        return view('index', $data);
    }

    public function selectProduct(Request $request)
    {
        $validator = $this->validatorItem($request->all());

        if ($validator->fails()){
            return redirect()->back()->withInput($request->all())->withErrors($validator->errors());
        }

        $fund = Coin::getTotal();
        $product = Product::find($request->input('product_id'));

        if ($product == null){
            return redirect()->back()->withInput($request->all())->withErrors(['product_id' => ['Product not found.']]);
        }

        $this->clearCoin();
        $data['item'] = null;
        $change = $fund - $product->price;

        if ($product->in_stock == 0 || $change < 0){
            //return got item false. product isn't available
            $data['total'] = Coin::getTotal();
            $data['coins'] = Coin::all();
        }
        else{
            $data['coins'] = $this->change($change);
            $data['total'] = Coin::getTotal();
            $data['item'] = $product;
            $this->clearCoin();
        }

        return view('result', $data);
    }

    public function refund()
    {
        $data['total'] = Coin::getTotal();
        $data['coins'] = Coin::all();
        $data['item'] = null;
        $this->clearCoin();

        return view('result', $data);
    }

    private function change($fund = 0)
    {
        $coins = Coin::orderByDesc('value')->get();
        foreach ($coins as $coin){
            $coin->amount = floor($fund / $coin->value);
            $coin->save();
            $fund = $fund % $coin->value;
        }

        return $coins;
    }

    private function validatorItem($data = [])
    {
        return Validator::make($data, [
            'product_id' => 'required|numeric|min:1'
        ]);
    }

    private function clearCoin()
    {
        return Coin::where('amount', '<>', 0)->update(['amount' => 0]);
    }
}

resources/views/index.blade.php
@extends('layout')
@section('content')
    <h2>Coin insert</h2>
    <div class="row">
        <div class="col-md-6">
            Total fund : {{ $total }} Baht.
        </div>
        <div class="col-md-6">
            <a class="btn btn-warning" href="{{ route('refund') }}">Refund</a>
            <a class="btn btn-success" href="{{ route('product.show') }}">Select product</a>
        </div>
    </div>
    <div class="row">
        <table class="table">
            <thead>
            <tr>
                <th scope="col">Coin</th>
                <th scope="col">Amount</th>
                <th scope="col">Insert</th>
            </tr>
            </thead>
            <tbody>
            @foreach($coins as $coin)
                <tr>
                    <td>{{ $coin->value }} Baht</td>
                    <td>{{ $coin->amount }} coin</td>
                    <td><a class="btn btn-info" href="{{ route('coin.insert', ['coin_value' => $coin->value]) }}">Coin {{ $coin->value }} Baht</a></td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>

@endsection

resources/views/layout.blade.php
<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">

    <title>Vending Machine</title>
    <style>
        .container{
            margin-top: 50px;
        }

        .row{
            margin: 20px;
        }
    </style>
</head>
<body>
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" href="/">Vending Machine</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item active">
                <a class="nav-link" href="/">Home <span class="sr-only">(current)</span></a>
            </li>
        </ul>
    </div>
</nav>
<div class="container">
    @yield('content')
</div>

<!-- Optional JavaScript -->
<!-- jQuery first, then Popper.js, then Bootstrap JS -->
<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
</body>
</html>

resources/views/product.blade.php
@extends('layout')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <h2>Products</h2>
            <p><strong>Total fund : {{ $fund }} Baht.</strong></p>
        </div>
    </div>
    <div class="row">
        @foreach($products as $product)
            <div class="col-md-4" style=" text-align: center;">
                <img src="{{ $product->image }}" alt="">
                <p>Name : {{ $product->name }}</p>
                <p>Price : {{ $product->price }}</p>
                <a class="btn btn-success" href="{{ route('select', ['product_id' => $product->id]) }}">Select</a>
            </div>
        @endforeach
    </div>
@endsection

resources/views/result.blade.php
@extends('layout')
@section('content')
    <div class="row" style="text-align: center;">
        <div class="col-md-6">
            @if($item == null)
                <h3>Can't get item</h3>
            @else
                <h3>Got item</h3>
                <img src="{{ $item->image }}" alt="">
                <p>{{ $item->name }}</p>
                <p>{{ $item->price }}</p>
            @endif
            <p>Total change : {{ $total }} Baht.</p>
        </div>
        <div class="col-md-6">
            <h2>Change coin</h2>
            <table class="table">
                <thead>
                <tr>
                    <th scope="col">Coin</th>
                    <th scope="col">Change amount </th>
                </tr>
                </thead>
                <tbody>
                @foreach($coins as $coin)
                    <tr>
                        <td>{{ $coin->value }} Baht</td>
                        <td>{{ $coin->amount }} coin</td>
                    </tr>
                @endforeach
                </tbody>
            </table>
        </div>
    </div>
@endsection